Index: drivers/filesystems/btrfs/fsctl.c
===================================================================
--- drivers/filesystems/btrfs/fsctl.c	(révision 74430)
+++ drivers/filesystems/btrfs/fsctl.c	(copie de travail)
@@ -2221,11 +2216,17 @@
                 flush_fcb_caches(Vcb);
                 
                 if (Vcb->need_write && !Vcb->readonly)
-                    do_write(Vcb, Irp, &rollback);
+                    Status = do_write(Vcb, Irp);
+                else
+                    Status = STATUS_SUCCESS;
                 
                 free_trees(Vcb);
                 
-                clear_rollback(Vcb, &rollback);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("do_write returned %08x\n", Status);
+                    ExReleaseResourceLite(&Vcb->tree_lock);
+                    goto end;
+                }
                 
                 flush_fcb_caches(Vcb);
                 
@@ -2292,7 +2293,7 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS get_compression(device_extension* Vcb, PIRP Irp) {
+static NTSTATUS get_compression(PIRP Irp) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     USHORT* compression;
     
@@ -2320,35 +2321,26 @@
 
 static void update_volumes(device_extension* Vcb) {
     LIST_ENTRY* le;
+    volume_device_extension* vde;
     
+    vde = Vcb->vde;
+    
     ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
-    ExAcquireResourceExclusiveLite(&volumes_lock, TRUE);
     
-    le = volumes.Flink;
+    ExAcquireResourceExclusiveLite(&vde->child_lock, TRUE);
+    
+    le = vde->children.Flink;
+
+    while (le != &vde->children) {
+        volume_child* vc = CONTAINING_RECORD(le, volume_child, list_entry);
         
-    while (le != &volumes) {
-        volume* v = CONTAINING_RECORD(le, volume, list_entry);
-        
-        if (RtlCompareMemory(&Vcb->superblock.uuid, &v->fsuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
-            LIST_ENTRY* le;
-            
-            le = Vcb->devices.Flink;
-            while (le != &Vcb->devices) {
-                device* dev = CONTAINING_RECORD(le, device, list_entry);
-                
-                if (RtlCompareMemory(&dev->devitem.device_uuid, &v->devuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
-                    v->gen1 = v->gen2 = Vcb->superblock.generation - 1;
-                    break;
-                }
-                
-                le = le->Flink;
-            }
-        }
-        
+        vc->generation = Vcb->superblock.generation - 1;
+
         le = le->Flink;
     }
     
-    ExReleaseResourceLite(&volumes_lock);
+    ExReleaseResourceLite(&vde->child_lock);
+    
     ExReleaseResourceLite(&Vcb->tree_lock);
 }
 
@@ -2355,7 +2347,7 @@
 static NTSTATUS dismount_volume(device_extension* Vcb, PIRP Irp) {
     NTSTATUS Status;
     KIRQL irql;
-    LIST_ENTRY rollback;
+    volume_device_extension* vde;
     
     TRACE("FSCTL_DISMOUNT_VOLUME\n");
     
@@ -2367,8 +2359,6 @@
         return STATUS_ACCESS_DENIED;
     }
     
-    InitializeListHead(&rollback);
-    
     Status = FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_DISMOUNT);
     if (!NT_SUCCESS(Status)) {
         WARN("FsRtlNotifyVolumeEvent returned %08x\n", Status);
@@ -2376,18 +2366,25 @@
     
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
     
-    flush_fcb_caches(Vcb);
+    if (!Vcb->locked) {
+        flush_fcb_caches(Vcb);
+        
+        if (Vcb->need_write && !Vcb->readonly) {
+            Status = do_write(Vcb, Irp);
+            
+            if (!NT_SUCCESS(Status))
+                ERR("do_write returned %08x\n", Status);
+        }
+    }
     
-    if (Vcb->need_write && !Vcb->readonly)
-        do_write(Vcb, Irp, &rollback);
-    
     free_trees(Vcb);
     
-    clear_rollback(Vcb, &rollback);
-    
     Vcb->removing = TRUE;
     update_volumes(Vcb);
     
+    vde = Vcb->vde;
+    vde->mounted_device = NULL;
+    
     ExReleaseResourceLite(&Vcb->tree_lock);
     
     IoAcquireVpbSpinLock(&irql);
@@ -2480,27 +2477,48 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS add_device(device_extension* Vcb, PIRP Irp, void* data, ULONG length, KPROCESSOR_MODE processor_mode) {
+void trim_whole_device(device* dev) {
+    DEVICE_MANAGE_DATA_SET_ATTRIBUTES dmdsa;
+    NTSTATUS Status;
+    
+    // FIXME - avoid "bootloader area"??
+    
+    dmdsa.Size = sizeof(DEVICE_MANAGE_DATA_SET_ATTRIBUTES);
+    dmdsa.Action = DeviceDsmAction_Trim;
+    dmdsa.Flags = DEVICE_DSM_FLAG_ENTIRE_DATA_SET_RANGE | DEVICE_DSM_FLAG_TRIM_NOT_FS_ALLOCATED;
+    dmdsa.ParameterBlockOffset = 0;
+    dmdsa.ParameterBlockLength = 0;
+    dmdsa.DataSetRangesOffset = 0;
+    dmdsa.DataSetRangesLength = 0;
+    
+    Status = dev_ioctl(dev->devobj, IOCTL_STORAGE_MANAGE_DATA_SET_ATTRIBUTES, &dmdsa, sizeof(DEVICE_MANAGE_DATA_SET_ATTRIBUTES), NULL, 0, TRUE, NULL);
+    if (!NT_SUCCESS(Status))
+        WARN("IOCTL_STORAGE_MANAGE_DATA_SET_ATTRIBUTES returned %08x\n", Status);
+}
+
+static NTSTATUS add_device(device_extension* Vcb, PIRP Irp, KPROCESSOR_MODE processor_mode) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     NTSTATUS Status;
     PFILE_OBJECT fileobj, mountmgrfo;
+    PDEVICE_OBJECT DeviceObject;
     HANDLE h;
-    LIST_ENTRY rollback, *le;
-    GET_LENGTH_INFORMATION gli;
+    LIST_ENTRY* le;
     device* dev;
     DEV_ITEM* di;
-    UINT64 dev_id;
+    UINT64 dev_id, size;
     UINT8* mb;
     UINT64* stats;
-    MOUNTDEV_NAME mdn1, *mdn2;
-    UNICODE_STRING volname, mmdevpath;
-    volume* v;
+    UNICODE_STRING mmdevpath, pnp_name, pnp_name2;
+    volume_child* vc;
     PDEVICE_OBJECT mountmgr;
     KEY searchkey;
     traverse_ptr tp;
     STORAGE_DEVICE_NUMBER sdn;
+    volume_device_extension* vde;
+    const GUID* pnp_guid;
+    GET_LENGTH_INFORMATION gli;
     
-    volname.Buffer = NULL;
+    pnp_name.Buffer = NULL;
     
     if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), processor_mode))
         return STATUS_PRIVILEGE_NOT_HELD;
@@ -2530,15 +2548,21 @@
         ERR("ObReferenceObjectByHandle returned %08x\n", Status);
         return Status;
     }
+
+    DeviceObject = fileobj->DeviceObject;
     
-    Status = is_device_part_of_mounted_btrfs_raid(fileobj->DeviceObject);
+    Status = get_device_pnp_name(DeviceObject, &pnp_name, &pnp_guid);
     if (!NT_SUCCESS(Status)) {
-        ERR("is_device_part_of_mounted_btrfs_raid returned %08x\n", Status);
+        ERR("get_device_pnp_name returned %08x\n", Status);
         ObDereferenceObject(fileobj);
         return Status;
     }
     
-    Status = dev_ioctl(fileobj->DeviceObject, IOCTL_DISK_IS_WRITABLE, NULL, 0, NULL, 0, TRUE, NULL);
+    // If this is a disk, we have been handed the PDO, so need to go up to find something we can use
+    if (RtlCompareMemory(pnp_guid, &GUID_DEVINTERFACE_DISK, sizeof(GUID)) == sizeof(GUID) && DeviceObject->AttachedDevice)
+        DeviceObject = DeviceObject->AttachedDevice;
+    
+    Status = dev_ioctl(DeviceObject, IOCTL_DISK_IS_WRITABLE, NULL, 0, NULL, 0, TRUE, NULL);
     if (!NT_SUCCESS(Status)) {
         ERR("IOCTL_DISK_IS_WRITABLE returned %08x\n", Status);
         ObDereferenceObject(fileobj);
@@ -2545,88 +2569,90 @@
         return Status;
     }
     
-    Status = dev_ioctl(fileobj->DeviceObject, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0,
-                       &gli, sizeof(gli), TRUE, NULL);
+    Status = is_device_part_of_mounted_btrfs_raid(DeviceObject);
     if (!NT_SUCCESS(Status)) {
-        ERR("error reading length information: %08x\n", Status);
+        ERR("is_device_part_of_mounted_btrfs_raid returned %08x\n", Status);
         ObDereferenceObject(fileobj);
         return Status;
     }
-    
-    if (gli.Length.QuadPart < 0x100000) {
-        ERR("device was not large enough to hold FS (%llx bytes, need at least 1 MB)\n", gli.Length.QuadPart);
-        ObDereferenceObject(fileobj);
-        return STATUS_INTERNAL_ERROR;
-    }
-    
-    Status = dev_ioctl(fileobj->DeviceObject, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0,
-                       &mdn1, sizeof(MOUNTDEV_NAME), TRUE, NULL);
-    if (Status == STATUS_BUFFER_OVERFLOW) {
-        mdn2 = ExAllocatePoolWithTag(PagedPool, offsetof(MOUNTDEV_NAME, Name[0]) + mdn1.NameLength, ALLOC_TAG);
-        if (!mdn2) {
-            ERR("out of memory\n");
-            ObDereferenceObject(fileobj);
-            return STATUS_INTERNAL_ERROR;
-        }
+
+    // if disk, check it has no partitions
+    if (RtlCompareMemory(pnp_guid, &GUID_DEVINTERFACE_DISK, sizeof(GUID)) == sizeof(GUID)) {
+        ULONG dlisize;
+        DRIVE_LAYOUT_INFORMATION_EX* dli = NULL;
         
-        Status = dev_ioctl(fileobj->DeviceObject, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0,
-                           mdn2, offsetof(MOUNTDEV_NAME, Name[0]) + mdn1.NameLength, TRUE, NULL);
+        dlisize = 0;
         
-        if (!NT_SUCCESS(Status)) {
-            ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
-            ObDereferenceObject(fileobj);
-            return Status;
+        do {
+            dlisize += 1024;
+            
+            if (dli)
+                ExFreePool(dli);
+            
+            dli = ExAllocatePoolWithTag(PagedPool, dlisize, ALLOC_TAG);
+            if (!dli) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto end2;
+            }
+        
+            Status = dev_ioctl(DeviceObject, IOCTL_DISK_GET_DRIVE_LAYOUT_EX, NULL, 0, dli, dlisize, TRUE, NULL);
+        } while (Status == STATUS_BUFFER_TOO_SMALL);
+        
+        if (NT_SUCCESS(Status) && dli->PartitionCount > 0) {
+            ExFreePool(dli);
+            ERR("not adding disk which has partitions\n");
+            Status = STATUS_DEVICE_NOT_READY;
+            goto end2;
         }
-    } else if (NT_SUCCESS(Status)) {
-        mdn2 = ExAllocatePoolWithTag(PagedPool, sizeof(MOUNTDEV_NAME), ALLOC_TAG);
-        if (!mdn2) {
-            ERR("out of memory\n");
+        
+        ExFreePool(dli);
+    }
+    
+    Status = dev_ioctl(DeviceObject, IOCTL_STORAGE_GET_DEVICE_NUMBER, NULL, 0,
+                       &sdn, sizeof(STORAGE_DEVICE_NUMBER), TRUE, NULL);
+    if (NT_SUCCESS(Status)) {
+        if (sdn.DeviceType != FILE_DEVICE_DISK) { // FIXME - accept floppies and CDs?
+            WARN("device was not disk\n"); 
             ObDereferenceObject(fileobj);
-            return STATUS_INTERNAL_ERROR;
+            return STATUS_INVALID_PARAMETER;
         }
-        
-        RtlCopyMemory(mdn2, &mdn1, sizeof(MOUNTDEV_NAME));
     } else {
-        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+        sdn.DeviceNumber = 0xffffffff;
+        sdn.PartitionNumber = 0xffffffff;
+    }
+    
+    Status = dev_ioctl(DeviceObject, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0,
+                        &gli, sizeof(gli), TRUE, NULL);
+    if (!NT_SUCCESS(Status)) {
+        ERR("error reading length information: %08x\n", Status);
         ObDereferenceObject(fileobj);
         return Status;
     }
     
-    if (mdn2->NameLength == 0) {
-        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned zero-length name\n");
+    size = gli.Length.QuadPart;
+    
+    if (size < 0x100000) {
+        ERR("device was not large enough to hold FS (%llx bytes, need at least 1 MB)\n", size);
         ObDereferenceObject(fileobj);
-        ExFreePool(mdn2);
         return STATUS_INTERNAL_ERROR;
     }
     
-    volname.Length = volname.MaximumLength = mdn2->NameLength;
-    volname.Buffer = ExAllocatePoolWithTag(PagedPool, volname.MaximumLength, ALLOC_TAG);
-    if (!volname.Buffer) {
-        ERR("out of memory\n");
-        ObDereferenceObject(fileobj);
-        ExFreePool(mdn2);
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
+    volume_removal(drvobj, &pnp_name);
     
-    RtlCopyMemory(volname.Buffer, mdn2->Name, volname.Length);
-    ExFreePool(mdn2);
-    
-    InitializeListHead(&rollback);
-    
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
         
-    if (Vcb->need_write) {
-        Status = do_write(Vcb, Irp, &rollback);
-        if (!NT_SUCCESS(Status)) {
-            ERR("do_write returned %08x\n", Status);
-            do_rollback(Vcb, &rollback);
-            goto end;
-        }
-    }
+    if (Vcb->need_write)
+        Status = do_write(Vcb, Irp);
+    else
+        Status = STATUS_SUCCESS;
     
     free_trees(Vcb);
     
-    clear_rollback(Vcb, &rollback);
+    if (!NT_SUCCESS(Status)) {
+        ERR("do_write returned %08x\n", Status);
+        goto end;
+    }
     
     dev = ExAllocatePoolWithTag(NonPagedPool, sizeof(device), ALLOC_TAG);
     if (!dev) {
@@ -2637,18 +2663,16 @@
     
     RtlZeroMemory(dev, sizeof(device));
 
-    dev->devobj = fileobj->DeviceObject;
+    dev->devobj = DeviceObject;
     dev->seeding = FALSE;
-    dev->length = gli.Length.QuadPart;
-    init_device(Vcb, dev, FALSE, TRUE);
+    init_device(Vcb, dev, TRUE);
     
     InitializeListHead(&dev->space);
     
-    if (gli.Length.QuadPart > 0x100000) { // add disk hole - the first MB is marked as used
-        Status = add_space_entry(&dev->space, NULL, 0x100000, gli.Length.QuadPart - 0x100000);
+    if (size > 0x100000) { // add disk hole - the first MB is marked as used
+        Status = add_space_entry(&dev->space, NULL, 0x100000, size - 0x100000);
         if (!NT_SUCCESS(Status)) {
             ERR("add_space_entry returned %08x\n", Status);
-            Status = STATUS_INTERNAL_ERROR;
             goto end;
         }
     }
@@ -2668,7 +2692,7 @@
     dev_id++;
     
     dev->devitem.dev_id = dev_id;
-    dev->devitem.num_bytes = gli.Length.QuadPart;
+    dev->devitem.num_bytes = size;
     dev->devitem.bytes_used = 0;
     dev->devitem.optimal_io_align = Vcb->superblock.sector_size;
     dev->devitem.optimal_io_width = Vcb->superblock.sector_size;
@@ -2690,10 +2714,10 @@
     
     RtlCopyMemory(di, &dev->devitem, sizeof(DEV_ITEM));
     
-    if (!insert_tree_item(Vcb, Vcb->chunk_root, 1, TYPE_DEV_ITEM, di->dev_id, di, sizeof(DEV_ITEM), NULL, Irp, &rollback)) {
-        ERR("insert_tree_item failed\n");
+    Status = insert_tree_item(Vcb, Vcb->chunk_root, 1, TYPE_DEV_ITEM, di->dev_id, di, sizeof(DEV_ITEM), NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
         ExFreePool(di);
-        Status = STATUS_INTERNAL_ERROR;
         goto end;
     }
     
@@ -2701,7 +2725,7 @@
     stats = ExAllocatePoolWithTag(PagedPool, sizeof(UINT64) * 5, ALLOC_TAG);
     if (!stats) {
         ERR("out of memory\n");
-        Status = STATUS_INTERNAL_ERROR;
+        Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
     
@@ -2714,19 +2738,29 @@
     Status = find_item(Vcb, Vcb->dev_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
+        ExFreePool(stats);
         goto end;
     }
     
-    if (!keycmp(tp.item->key, searchkey))
-        delete_tree_item(Vcb, &tp, &rollback);
+    if (!keycmp(tp.item->key, searchkey)) {
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            ExFreePool(stats);
+            goto end;
+        }
+    }
     
-    if (!insert_tree_item(Vcb, Vcb->dev_root, 0, TYPE_DEV_STATS, di->dev_id, stats, sizeof(UINT64) * 5, NULL, Irp, &rollback)) {
-        ERR("insert_tree_item failed\n");
+    Status = insert_tree_item(Vcb, Vcb->dev_root, 0, TYPE_DEV_STATS, di->dev_id, stats, sizeof(UINT64) * 5, NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
         ExFreePool(stats);
-        Status = STATUS_INTERNAL_ERROR;
         goto end;
     }
     
+    if (dev->trim && !dev->readonly && !Vcb->options.no_trim)
+        trim_whole_device(dev);
+    
     // We clear the first megabyte of the device, so Windows doesn't identify it as another FS
     mb = ExAllocatePoolWithTag(PagedPool, 0x100000, ALLOC_TAG);
     if (!mb) {
@@ -2737,7 +2771,7 @@
     
     RtlZeroMemory(mb, 0x100000);
     
-    Status = write_data_phys(fileobj->DeviceObject, 0, mb, 0x100000);
+    Status = write_data_phys(DeviceObject, 0, mb, 0x100000);
     if (!NT_SUCCESS(Status)) {
         ERR("write_data_phys returned %08x\n", Status);
         goto end;
@@ -2745,71 +2779,104 @@
     
     ExFreePool(mb);
     
-    v = ExAllocatePoolWithTag(PagedPool, sizeof(volume), ALLOC_TAG);
-    if (!v) {
+    vde = Vcb->vde;
+    
+    vc = ExAllocatePoolWithTag(NonPagedPool, sizeof(volume_child), ALLOC_TAG);
+    if (!vc) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
     
-    v->fsuuid = Vcb->superblock.uuid;
-    v->devuuid = dev->devitem.device_uuid;
-    v->devnum = dev_id;
-    v->devpath = volname;
-    v->length = gli.Length.QuadPart;
-    v->gen1 = v->gen2 = Vcb->superblock.generation;
-    v->seeding = FALSE;
-    v->processed = TRUE;
+    vc->uuid = dev->devitem.device_uuid;
+    vc->devid = dev_id;
+    vc->generation = Vcb->superblock.generation;
+    vc->devobj = DeviceObject;
+    vc->notification_entry = NULL;
     
-    ExAcquireResourceExclusiveLite(&volumes_lock, TRUE);
-    InsertTailList(&volumes, &v->list_entry);
-    ExReleaseResourceLite(&volumes_lock);
+    Status = IoRegisterPlugPlayNotification(EventCategoryTargetDeviceChange, 0, fileobj,
+                                            drvobj, pnp_removal, vde, &vc->notification_entry);
+    if (!NT_SUCCESS(Status))
+        WARN("IoRegisterPlugPlayNotification returned %08x\n", Status);
     
-    volname.Buffer = NULL;
+    pnp_name2 = pnp_name;
     
-    Status = dev_ioctl(fileobj->DeviceObject, IOCTL_STORAGE_GET_DEVICE_NUMBER, NULL, 0,
-                       &sdn, sizeof(STORAGE_DEVICE_NUMBER), TRUE, NULL);
-    if (!NT_SUCCESS(Status)) {
-        WARN("IOCTL_STORAGE_GET_DEVICE_NUMBER returned %08x\n", Status);
-        v->disk_num = 0;
-        v->part_num = 0;
-    } else {
-        v->disk_num = sdn.DeviceNumber;
-        v->part_num = sdn.PartitionNumber;
+    if (pnp_name.Length > 4 * sizeof(WCHAR) && pnp_name.Buffer[0] == '\\' && (pnp_name.Buffer[1] == '\\' || pnp_name.Buffer[1] == '?') &&
+        pnp_name.Buffer[2] == '?' && pnp_name.Buffer[3] == '\\') {
+        pnp_name2.Buffer = &pnp_name2.Buffer[3];
+        pnp_name2.Length -= 3 * sizeof(WCHAR);
+        pnp_name2.MaximumLength -= 3 * sizeof(WCHAR);
     }
     
+    vc->pnp_name.Length = vc->pnp_name.MaximumLength = pnp_name2.Length;
+    
+    if (pnp_name2.Length == 0)
+        vc->pnp_name.Buffer = NULL;
+    else {
+        vc->pnp_name.Buffer = ExAllocatePoolWithTag(PagedPool, pnp_name2.Length, ALLOC_TAG);
+        if (!vc->pnp_name.Buffer) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto end;
+        }
+        
+        RtlCopyMemory(vc->pnp_name.Buffer, pnp_name2.Buffer, pnp_name2.Length);
+    }
+    
+    vc->size = size;
+    vc->seeding = FALSE;
+    vc->disk_num = sdn.DeviceNumber;
+    vc->part_num = sdn.PartitionNumber;
+    vc->had_drive_letter = FALSE;
+    
+    ExAcquireResourceExclusiveLite(&vde->child_lock, TRUE);
+    InsertTailList(&vde->children, &vc->list_entry);
+    vde->num_children++;
+    vde->children_loaded++;
+    ExReleaseResourceLite(&vde->child_lock);
+    
     RtlInitUnicodeString(&mmdevpath, MOUNTMGR_DEVICE_NAME);
     Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &mountmgrfo, &mountmgr);
     if (!NT_SUCCESS(Status))
         ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
     else {
-        remove_drive_letter(mountmgr, v);
+        Status = remove_drive_letter(mountmgr, &pnp_name);
+        if (!NT_SUCCESS(Status) && Status != STATUS_NOT_FOUND)
+            WARN("remove_drive_letter returned %08x\n", Status);
         
+        vc->had_drive_letter = NT_SUCCESS(Status);
+        
         ObDereferenceObject(mountmgrfo);
     }
     
     Vcb->superblock.num_devices++;
-    Vcb->superblock.total_bytes += gli.Length.QuadPart;
+    Vcb->superblock.total_bytes += size;
     Vcb->devices_loaded++;
     InsertTailList(&Vcb->devices, &dev->list_entry);
     
-    ObReferenceObject(fileobj->DeviceObject);
+    // FIXME - send notification that volume size has increased
     
-    do_write(Vcb, Irp, &rollback);
-
-    free_trees(Vcb);
+    ObReferenceObject(DeviceObject); // once for vde
+    ObReferenceObject(DeviceObject); // and again for Vcb
     
-    clear_rollback(Vcb, &rollback);
+    Status = do_write(Vcb, Irp);
+    if (!NT_SUCCESS(Status))
+        ERR("do_write returned %08x\n", Status);
     
-    Status = STATUS_SUCCESS;
+end:
+    free_trees(Vcb);
     
-end:
     ExReleaseResourceLite(&Vcb->tree_lock);
+    
+end2:
     ObDereferenceObject(fileobj);
     
-    if (volname.Buffer)
-        ExFreePool(volname.Buffer);
+    if (pnp_name.Buffer)
+        ExFreePool(pnp_name.Buffer);
     
+    if (NT_SUCCESS(Status))
+        FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_CHANGE_SIZE);
+    
     return Status;
 }
 
@@ -2848,7 +2915,51 @@
     return STATUS_SUCCESS;
 }
 
-NTSTATUS fsctl_request(PDEVICE_OBJECT DeviceObject, PIRP Irp, UINT32 type, BOOL user) {
+static NTSTATUS reset_stats(device_extension* Vcb, void* data, ULONG length, KPROCESSOR_MODE processor_mode) {
+    UINT64 devid;
+    NTSTATUS Status;
+    LIST_ENTRY* le;
+    
+    if (length < sizeof(UINT64))
+        return STATUS_INVALID_PARAMETER;
+    
+    if (Vcb->readonly)
+        return STATUS_MEDIA_WRITE_PROTECTED;
+    
+    if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), processor_mode))
+        return STATUS_PRIVILEGE_NOT_HELD;
+    
+    devid = *((UINT64*)data);
+    
+    ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
+    
+    le = Vcb->devices.Flink;
+
+    while (le != &Vcb->devices) {
+        device* dev = CONTAINING_RECORD(le, device, list_entry);
+        
+        if (dev->devitem.dev_id == devid) {
+            RtlZeroMemory(dev->stats, sizeof(UINT64) * 5);
+            dev->stats_changed = TRUE;
+            Vcb->stats_changed = TRUE;
+            Vcb->need_write = TRUE;
+            Status = STATUS_SUCCESS;
+            goto end;
+        }
+        
+        le = le->Flink;
+    }
+    
+    WARN("device %llx not found\n", devid);
+    Status = STATUS_INVALID_PARAMETER;
+    
+end:
+    ExReleaseResourceLite(&Vcb->tree_lock);
+    
+    return Status;
+}
+
+NTSTATUS fsctl_request(PDEVICE_OBJECT DeviceObject, PIRP Irp, UINT32 type) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     NTSTATUS Status;
     
@@ -2915,7 +3026,7 @@
             break;
 
         case FSCTL_GET_COMPRESSION:
-            Status = get_compression(DeviceObject->DeviceExtension, Irp);
+            Status = get_compression(Irp);
             break;
 
         case FSCTL_SET_COMPRESSION:
@@ -2948,8 +3059,7 @@
             break;
 
         case FSCTL_FILESYSTEM_GET_STATISTICS:
-            Status = fs_get_statistics(DeviceObject, IrpSp->FileObject, Irp->AssociatedIrp.SystemBuffer,
-                                       IrpSp->Parameters.FileSystemControl.OutputBufferLength, &Irp->IoStatus.Information);
+            Status = fs_get_statistics(Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.OutputBufferLength, &Irp->IoStatus.Information);
             break;
 
         case FSCTL_GET_NTFS_VOLUME_DATA:
@@ -3054,7 +3164,7 @@
             break;
 
         case FSCTL_QUERY_ALLOCATED_RANGES:
-            Status = query_ranges(DeviceObject->DeviceExtension, IrpSp->FileObject, IrpSp->Parameters.FileSystemControl.Type3InputBuffer,
+            Status = query_ranges(IrpSp->FileObject, IrpSp->Parameters.FileSystemControl.Type3InputBuffer,
                                   IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp->UserBuffer,
                                   IrpSp->Parameters.FileSystemControl.OutputBufferLength, &Irp->IoStatus.Information);
             break;
@@ -3364,15 +3474,39 @@
             break;
             
         case FSCTL_BTRFS_ADD_DEVICE:
-            Status = add_device(DeviceObject->DeviceExtension, Irp, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp->RequestorMode);
+            Status = add_device(DeviceObject->DeviceExtension, Irp, Irp->RequestorMode);
             break;
             
         case FSCTL_BTRFS_REMOVE_DEVICE:
             Status = remove_device(DeviceObject->DeviceExtension, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp->RequestorMode);
-        break;
+            break;
         
         case FSCTL_BTRFS_GET_UUID:
             Status = query_uuid(DeviceObject->DeviceExtension, map_user_buffer(Irp), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
+            break;
+        
+        case FSCTL_BTRFS_START_SCRUB:
+            Status = start_scrub(DeviceObject->DeviceExtension, Irp->RequestorMode);
+            break;
+        
+        case FSCTL_BTRFS_QUERY_SCRUB:
+            Status = query_scrub(DeviceObject->DeviceExtension, Irp->RequestorMode, map_user_buffer(Irp), IrpSp->Parameters.FileSystemControl.OutputBufferLength);
+            break;
+        
+        case FSCTL_BTRFS_PAUSE_SCRUB:
+            Status = pause_scrub(DeviceObject->DeviceExtension, Irp->RequestorMode);
+            break;
+
+        case FSCTL_BTRFS_RESUME_SCRUB:
+            Status = resume_scrub(DeviceObject->DeviceExtension, Irp->RequestorMode);
+            break;
+
+        case FSCTL_BTRFS_STOP_SCRUB:
+            Status = stop_scrub(DeviceObject->DeviceExtension, Irp->RequestorMode);
+            break;
+            
+        case FSCTL_BTRFS_RESET_STATS:
+            Status = reset_stats(DeviceObject->DeviceExtension, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.FileSystemControl.InputBufferLength, Irp->RequestorMode);
         break;
 
         default:
Index: drivers/filesystems/btrfs/galois.c
===================================================================
--- drivers/filesystems/btrfs/galois.c	(révision 74430)
+++ drivers/filesystems/btrfs/galois.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
